<template>
  <div class="post root-result">
    <div class="thumbnail">
      <a
        class="img"
        :title="watchMessage"
        target="_blank"
        rel="nofollow noreferrer noopener"
        :href="post.url"
      >
        <img :src="post.thumbnailUrl" alt="" />
      </a>
    </div>

    <div class="information">
      <h2 class="title">
        <a
          :title="watchMessage"
          target="_blank"
          rel="nofollow noreferrer noopener"
          :href="post.url"
          >{{ post.title }}</a
        >
      </h2>

      <!-- eslint-disable-next-line vue/no-v-html -->
      <div class="description" v-html="post.description"></div>

      <div class="metadatas">
        <div class="by-account">
          <label>{{ $gettext('Created by') }}</label>
          <actor-miniature
            type="account"
            :actor="post.ownerAccount"
          ></actor-miniature>
        </div>

        <div>
          <label>{{ $gettext('In') }}</label>

          <actor-miniature type="group" :actor="post.group"></actor-miniature>
        </div>

        <div>
          <label>{{ $gettext('Updated on') }}</label>

          <div class="value">{{ updateDate }}</div>
        </div>
      </div>

      <div class="button">
        <a
          class="button-link"
          target="_blank"
          rel="nofollow noreferrer noopener"
          :href="post.url"
        >
          {{ watchMessage }}
        </a>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
  import { defineComponent, PropType } from 'vue'
  import ActorMiniature from '../ActorMiniature.vue'
  import { Post } from '../../../../server/types/post.model'

  export default defineComponent({
    components: {
      'actor-miniature': ActorMiniature,
    },

    props: {
      post: {
        type: Object as PropType<Post>,
        required: true,
      },
    },

    computed: {
      host(): string {
        const url = this.post.url

        return new URL(url as string).host
      },

      updateDate(): string {
        return new Date(this.post.updated).toLocaleDateString()
      },

      watchMessage(): string {
        return this.$gettextInterpolate(
          this.$gettext('Read the post on %{host}'),
          { host: this.host }
        )
      },
    },
  })
</script>
